require "ISUI/ISCharacterScreen"

local hookedZValue = 0;
local genuineZValue = 0;
function hooked_ISUIElement_setHeightAndParentHeight(ownInstance,z)
    local smallFontHgt = getTextManager():getFontFromEnum(UIFont.Small):getLineHeight();
    genuineZValue = z;
    --print( "hooked_ISUIElement_setHeightAndParentHeight "..z );
    if z > smallFontHgt * 2 + 10 then
        hookedZValue = z - smallFontHgt * 2 - 10;
    end
end

genuine_ISCharacterScreen_render = ISCharacterScreen.render
function ISCharacterScreen:render()
    local genuine_ISUIElement_setHeightAndParentHeight = ISUIElement.setHeightAndParentHeight;--prepare unhooking of the height function
    local player = getSpecificPlayer(0);
    if player:getModData().AKCModData ~= nil then 
        ISUIElement.setHeightAndParentHeight = hooked_ISUIElement_setHeightAndParentHeight;--hook the height function
    end

    genuine_ISCharacterScreen_render(self);--call genuine render with possibly hooked height function

    if player:getModData().AKCModData ~= nil then
    
        if hookedZValue ~= 0 then
            local totalKill = player:getModData().AKCModData.tk;
            local weaponKill = player:getZombieKills();
            local otherKill = totalKill - weaponKill;
            local fireKill = player:getModData().AKCModData.fk;
            local carKill = player:getModData().AKCModData.ck;
            
            local textWid1 = getTextManager():MeasureStringX(UIFont.Small, getText("IGUI_char_Favourite_Weapon"))
            local textWid2 = getTextManager():MeasureStringX(UIFont.Small, getText("IGUI_char_Zombies_Killed"))
            local textWid3 = getTextManager():MeasureStringX(UIFont.Small, getText("IGUI_char_Survived_For"))
            local x = 20 + math.max(textWid1, math.max(textWid2, textWid3)) + getTextManager():MeasureStringX(UIFont.Small, ""..weaponKill)--retrieve x value the way PZ does it. add the x offset for current "weapon kill"

            self:drawText("(wpn) + "..fireKill.."(fire) + "..carKill.."(car) = " .. totalKill, x + 10, hookedZValue, 1,1,1,0.5, UIFont.Small);--add text with corrected kill numbers
        end
        
        ISUIElement.setHeightAndParentHeight = genuine_ISUIElement_setHeightAndParentHeight;--unhook the height function
        
        self:setHeightAndParentHeight(genuineZValue);--call the real function, hope for genuineZ being valid
    end
end
